/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/

void openbio::init()
{
  mymode=0;
  mysocket=Qt::Socket(this);
  this->connect(mysocket, SIGNAL 'connected()', SLOT 'connected()' );
  this->connect(mysocket, SIGNAL 'readyRead()', SLOT 'gotData()' );
  this->connect(mysocket, SIGNAL 'error(int)', SLOT 'caterror(int)' );
  mysocket->connectToHost("127.0.0.1",1072);
  print "mysocket: ".mysocket."\n";
    
  StatusLabel->setText("");
  
  mytimer=Qt::Timer();
  this->connect(mytimer, SIGNAL 'timeout()', SLOT 'onmyTimer()' );  
}

void openbio::readln(char *text)
{
  if(!mysocket->canReadLine())
  {
    mysocket->waitForMore (500);
  }
  my $ret= mysocket->readLine();
  chop($ret);
  return $ret;
}

void openbio::sendit(char *text)
{
  print $_[0];
  $openbio::server->write($_[0]) if(defined $openbio::server);
  mysocket->writeBlock($_[0],length($_[0]));
  mysocket->flush();
}


void openbio::EnrollButton_clicked()
{
  StatusLabel->setText("");
  sendit("E");
  sendit(username->text());
  sendit("\n");
  my $text="";
  readln($text);
  $text="";
  readln($text);
  UpdateUsers();
}

void openbio::AutoButton_clicked()
{
  StatusLabel->setText("");
  sendit("A");
  sendit(username->text());
  sendit("\n");
  my $text="";
  readln($text);
  $text="";
  readln($text);
  UpdateUsers();
}

void openbio::IdentifyButton_clicked()
{
  StatusLabel->setText("");
  sendit("I");
  sendit(identselect->text());
  sendit("\n");
}

void openbio::IdentAll_clicked()
{
  StatusLabel->setText("");
  sendit("I*\n");
}
void openbio::VerifyButton_clicked()
{
  StatusLabel->setText("");
  sendit("V");
  sendit(userlist->currentText());
  sendit("\n");
}

void openbio::SpecialButton_clicked()
{
  StatusLabel->setText("");
  sendit(spezialcommand->text());
  sendit("\n");

}

void openbio::onmyTimer()
{
  if(Erkennung->isOn())
  {
    StatusLabel->setText("");
    sendit("I*\n");
  }
  else
  {
    print "Erkennung schon wieder aus!\n";
  }
}

void openbio::Kamera_clicked()
{
  sendit("J\n");
  my $text="";
  readln($text);
  my $bild = Qt::Pixmap("camera.jpg","JPEG",0);
  # $bild->resize(320,240);
  Kamera->setPixmap($bild);
  # system("xv camera.jpg");
}

void openbio::UpdateUsers()
{
  my $text="";
  mymode=1;
  sendit("U\n");
  userlist->clear();
  print "Suche User ...\n";
  $text=readln();
  while($text ne "")
  {
    userlist->insertItem($text);
    $text=readln();
  }
  mymode=0;
#    userlist->insertStringList( Qt::StringList::split("\n",$text,0));

}


void openbio::connected()
{
  Connection->setText("Connected.\n");
  sendit("M1\n");
#  sendit("GET /\n\n\n");
  UpdateUsers();

}


void openbio::gotData()
{
  my @State=("Idle", "HostLookup", "Connecting", "Connected", "Closing", "Connection","Connected");
  Connection->setText("Verbindung: ".$State[mysocket->state()]);
  return if(mymode==1);  
  StatusLabel->setText(StatusLabel->text()."Got from Server: ");  
  my $size=mysocket->bytesAvailable();
  my $buffer=" "x$size;
  mysocket->readBlock($buffer,$size);
  StatusLabel->setText(StatusLabel->text().$buffer."\n");
  print $buffer;
}


void openbio::caterror(int value)
{
  MessageBox()->warning(this,"OpenBiometry Admin","Konnte keine Verbindung zum Server aufbauen.\n");
#system("./server &");
  #    MessageBox()->information(this,"OpenBiometry Admin","Konnte keine Verbindung zum Server aufbauen! Bitte kontrollieren Sie den Server auf Port 1072.");
#    print "Konnte keine Verbindung zum Server aufbauen! Bitte kontrollieren Sie den Server auf Port 1072.\n";

}


void openbio::Erkennung_toggled( bool )
{
  if($_[0])  
  {
    mytimer->start(1000);
  }
  else
  {
    mytimer->stop();
  }
}
