
### do not edit Makefile.PL, edit Makefile.PL.in

use Config;

$x{'LIBPNG'}  =   '-lpng -lz -lm';
$x{'LIBJPEG'} =   '-ljpeg';
$x{'LIBSM'}   =   '-lSM -lICE';
$x{'LIBSOCKET'} = '';
$x{'LIB_X11'} =   '-lX11 $(LIBSOCKET)';
$x{'LIB_X11'} =~ s/\$\((.*?)\)/$x{$1}/g;

my $objects='Qt$(OBJ_EXT) handlers$(OBJ_EXT)';
my $qtlib ='-lqt-mt  $(LIBPNG) -lXext $(LIB_X11) $(LIBSM) -lpthread';
$qtlib =~s/\$\((.*?)\)/$x{$1}/g;
my $rpath='yes';

my $cxx = 'g++';
my $sh= '/bin/sh';
my $topdir= '../';
my $libtool_rpath = `${topdir}/libtool --mode=link $cxx -o foo.so foo.o -R /opt/kde3/lib 2>/dev/null`;
$libtool_rpath = "" unless $libtool_rpath =~ s/.*foo.so foo.o//s;
chomp $libtool_rpath;
$rpath = $rpath eq "yes" ? ($libtool_rpath ? $libtool_rpath : "-Wl,--rpath -Wl,/opt/kde3/lib"):"";

my @scripts = ("bin/pqtsh", "bin/pqtapi");

###

use ExtUtils::MakeMaker;
use Cwd;

my $pwd = getcwd;
my $localsmoke = $pwd."/../smoke/qt/.libs";


# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.

WriteMakefile(
    'NAME'		=> 'Qt',
    'VERSION_FROM'	=> 'Qt.pm', # finds $VERSION
    'PREREQ_PM'		=> {}, # e.g., Module::Name => 1.1,
    'INC'		=> "-I/opt/kde3/include -I/usr/lib/qt3/include -I/usr/X11R6/include  -I. -I../smoke",
    'LIBS'		=> ["-L/usr/X11R6/lib -L/usr/lib/qt3/lib -L/opt/kde3/lib  -L$localsmoke -lcrypt $qtlib -lsmokeqt"],
#   'XS'		=> {'Qt.xs' => 'Qt.cpp'}, # does not work ... still expects Qt.c 
    'XSOPT'		=> "-C++",
    'OBJECT'		=> "$objects",  # Object files
    'CC'		=> 'g++',
    'INST_BIN'          => './bin',
    'DEFINE'            => '-Wnon-virtual-dtor -Wno-long-long -Wundef -Wall -pedantic -W -Wpointer-arith -Wmissing-prototypes -Wwrite-strings -O2 -fno-exceptions -fno-check-new',
    'H'                 => ["marshall.h", "perlqt.h", "smokeperl.h"],
    'ABSTRACT'		=> "An OO interface to Trolltech's Qt toolkit",
    'dynamic_lib'       => {'OTHERLDFLAGS' => $rpath},
    ($] >= 5.005 ?    ## Add these new keywords supported since 5.005
      (
       AUTHOR     => 'Ashley Winters <qaqortog@nwlink.com>') : ()),
);

sub MY::clean {
                   package MY;
                   my $i = shift->SUPER::clean(@_);
                   my $pl = '$(PERL) Makefile.PL';
                   $i =~ s/\n+$/\n\t$pl$&/s;
                   $i;
}

sub MY::const_loadlibs {
                   package MY;
                   my $i = shift->SUPER::const_loadlibs(@_);
                   # hacks for linking against a non-yet-installed smoke
                   $i =~ s/((?:EXTRALIBS|LDLOADLIBS).*?)\n/$1 -L$localsmoke -lsmokeqt\n/gs unless $i =~/-lsmokeqt/;
                   $i =~ s#(LD_RUN_PATH.*?)(${localsmoke})?\n#"$1".($2?"":":")."/opt/kde3/lib\n"#se;
                   $i;
}

sub MY::dist {
		  package MY;
                   my $i = shift->SUPER::dist(@_);
                   $i =~ s#(DISTVNAME =).*?\n#$1 \$(distdir)\n#s;
                   $i;
}

for my $s( @scripts )
{
    rename( $s, $s.".in");
    open( IN, "$s.in" );
    open( OUT, ">$s" );
    <IN>;
    print OUT ($Config{'startperl'} ?  $Config{'startperl'}."\n" : $_ );
    while( <IN> )
    {  print OUT  }
    close IN;
    close OUT;
    unlink $s . ".in";
    chmod 0755, $s;
}
