#!/usr/bin/perl -w

## This program is based on an example program for Qt. It
## may be used, distributed and modified without limitation.
##
## Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.

# When a new client connects, the server constructs a Qt::Socket and all
# communication with the client is done over this Socket object. Qt::Socket
# works asynchronously - this means that all the communication is done
# through the two slots readClient() and discardClient().

# HttpInfo provides a simple graphical user interface to the server and shows
# the actions of the server.

package HttpInfo;

use Qt;
use Qt::isa qw(Qt::VBox);
use Qt::slots
    connected    => [],
    endConnect    => [],
    wroteToClient => [];
use Qt::attributes qw(
    mysocket
    infoText
);

sub NEW
{
  my @State=("Idle", "HostLookup", "Connecting", "Connected", "Closing", "Connection","Connected");
  shift->SUPER::NEW(@_);
  my $itext = "This is a small httpd example.\nYou can connect with your\nweb browser to port 80\n";
  my $lb = Label( $itext, this );
  $lb->setAlignment( &AlignHCenter );
  infoText = TextView( this );
  my $quit = PushButton( "quit" , this );

  this->connect($quit, SIGNAL 'pressed()', Qt::app(), SLOT 'quit()' );

  infoText->append("New connection");
  mysocket=Qt::Socket(this);
  mysocket->connectToHost("127.0.0.1",80);
  this->connect(mysocket, SIGNAL 'readyRead()', SLOT 'wroteToClient()' );
  this->connect(mysocket, SIGNAL 'connected()', SLOT 'connected()' );
 
}

sub connected
{
  infoText->append("Connected.\n");
  mysocket->writeBlock("GET /\n\n\n",8);
#  mysocket->
}

sub wroteToClient
{
  infoText->append("Wrote to client: ");
  my $size=mysocket->bytesAvailable();
  my $buffer=" "x$size;
  mysocket->readBlock($buffer,$size);
  infoText->append($buffer);
}

1;

package main;
use Qt;
use HttpInfo;

my $app = Qt::Application(\@ARGV);
my $info = HttpInfo;
$app->setMainWidget($info);
$info->show;
exit $app->exec;


